﻿using MiniExcelLibs.Attributes;
using System;

namespace SlnMesnac.RfidUpload.Model
{
    /// <summary>
    /// 指令信息
    /// </summary>
    public class InstructionInfo
    {
        [ExcelColumn(Name = "no", Index = 0), ExcelColumnWidth(23)]
        public int no { get; set; }
        /// <summary>
        /// 
        /// </summary>
        [ExcelColumn(Name = "stx",Index = 1),ExcelColumnWidth(23)]
        public string stx { get; set; }

        /// <summary>
        /// 报文长度，包含帧头、校验
        /// </summary>
        [ExcelColumn(Name = "len", Index = 2), ExcelColumnWidth(23)]
        public int len { get; set; }

        /// <summary>
        /// 报文类型0x31
        /// </summary>
        [ExcelColumn(Name = "cmd", Index = 3), ExcelColumnWidth(23)]
        public byte cmd { get; set; }

        /// <summary>
        /// 擦除状态：0-成功；1-失败
        /// </summary>
        [ExcelColumn(Name = "status", Index = 4), ExcelColumnWidth(23)]
        public int status { get; set; }

        /// <summary>
        /// 数据
        /// </summary>
        [ExcelColumn(Name = "data", Index = 5), ExcelColumnWidth(53)]
        public string data { get; set; }

        /// <summary>
        /// 异或和校验，10进制
        /// </summary>
        [ExcelColumn(Name = "xor", Index = 6), ExcelColumnWidth(23)]
        public byte xor { get; set; }

        /// <summary>
        /// 记录时间
        /// </summary>
        [ExcelColumn(Name = "recordtime", Index = 7), ExcelColumnWidth(23)]
        public DateTime recordtime { get; set; }


    }
}